aboutsummaryrefslogtreecommitdiffhomepage
diff options
context:
space:
mode:
authorGravatar Jisi Liu <jisi.liu@gmail.com>2017-07-24 20:44:59 -0700
committerGravatar Jisi Liu <jisi.liu@gmail.com>2017-07-24 20:44:59 -0700
commitce4416705b0f7e0dc7352618722d98ea268e4d4a (patch)
tree30925e44dadf18b92894be6fdf5129dbbee00869
parent11b4d5ec73ca5667fdd0927a7c9ed47707defa11 (diff)
parent4ae94d69ffd450dcf4b108c9367aa91e1f55dc7d (diff)
Merge remote-tracking branch 'origin/3.4.x' into vb
-rwxr-xr-xpython/google/protobuf/internal/encoder.py2
-rwxr-xr-xpython/google/protobuf/internal/message_test.py3
-rwxr-xr-xsrc/google/protobuf/compiler/zip_output_unittest.sh54
3 files changed, 36 insertions, 23 deletions
diff --git a/python/google/protobuf/internal/encoder.py b/python/google/protobuf/internal/encoder.py
index f8c36390..ebec42e5 100755
--- a/python/google/protobuf/internal/encoder.py
+++ b/python/google/protobuf/internal/encoder.py
@@ -819,7 +819,7 @@ def MapEncoder(field_descriptor):
encode_message = MessageEncoder(field_descriptor.number, False, False)
def EncodeField(write, value, deterministic):
- value_keys = sorted(value.iterkeys()) if deterministic else value.iterkeys()
+ value_keys = sorted(value.keys()) if deterministic else value.keys()
for key in value_keys:
entry_msg = message_type._concrete_class(key=key, value=value[key])
encode_message(write, entry_msg, deterministic)
diff --git a/python/google/protobuf/internal/message_test.py b/python/google/protobuf/internal/message_test.py
index 6f60586a..29a515b2 100755
--- a/python/google/protobuf/internal/message_test.py
+++ b/python/google/protobuf/internal/message_test.py
@@ -166,6 +166,9 @@ class MessageTest(BaseTestCase):
def __nonzero__(self):
raise BadArgError()
+ def __bool__(self):
+ raise BadArgError()
+
with self.assertRaises(BadArgError):
golden_message.SerializeToString(deterministic=BadArg())
diff --git a/src/google/protobuf/compiler/zip_output_unittest.sh b/src/google/protobuf/compiler/zip_output_unittest.sh
index 8cd80e38..f8597912 100755
--- a/src/google/protobuf/compiler/zip_output_unittest.sh
+++ b/src/google/protobuf/compiler/zip_output_unittest.sh
@@ -59,32 +59,42 @@ $PROTOC \
|| fail 'protoc failed.'
echo "Testing output to zip..."
-$UNZIP -t $TEST_TMPDIR/testzip.zip > $TEST_TMPDIR/testzip.list || fail 'unzip failed.'
+if $UNZIP -h > /dev/null; then
+ $UNZIP -t $TEST_TMPDIR/testzip.zip > $TEST_TMPDIR/testzip.list \
+ || fail 'unzip failed.'
-grep 'testing: testzip\.pb\.cc *OK$' $TEST_TMPDIR/testzip.list > /dev/null \
- || fail 'testzip.pb.cc not found in output zip.'
-grep 'testing: testzip\.pb\.h *OK$' $TEST_TMPDIR/testzip.list > /dev/null \
- || fail 'testzip.pb.h not found in output zip.'
-grep 'testing: testzip_pb2\.py *OK$' $TEST_TMPDIR/testzip.list > /dev/null \
- || fail 'testzip_pb2.py not found in output zip.'
-grep -i 'manifest' $TEST_TMPDIR/testzip.list > /dev/null \
- && fail 'Zip file contained manifest.'
+ grep 'testing: testzip\.pb\.cc *OK$' $TEST_TMPDIR/testzip.list > /dev/null \
+ || fail 'testzip.pb.cc not found in output zip.'
+ grep 'testing: testzip\.pb\.h *OK$' $TEST_TMPDIR/testzip.list > /dev/null \
+ || fail 'testzip.pb.h not found in output zip.'
+ grep 'testing: testzip_pb2\.py *OK$' $TEST_TMPDIR/testzip.list > /dev/null \
+ || fail 'testzip_pb2.py not found in output zip.'
+ grep -i 'manifest' $TEST_TMPDIR/testzip.list > /dev/null \
+ && fail 'Zip file contained manifest.'
+else
+ echo "Warning: 'unzip' command not available. Skipping test."
+fi
echo "Testing output to jar..."
-$JAR tf $TEST_TMPDIR/testzip.jar > $TEST_TMPDIR/testzip.list || fail 'jar failed.'
+if $JAR c $TEST_TMPDIR/testzip.proto > /dev/null; then
+ $JAR tf $TEST_TMPDIR/testzip.jar > $TEST_TMPDIR/testzip.list \
+ || fail 'jar failed.'
-# Check that -interface.jar timestamps are normalized:
-if [[ "$(TZ=UTC $JAR tvf $TEST_TMPDIR/testzip.jar)" != *'Tue Jan 01 00:00:00 UTC 1980'* ]]; then
- fail 'Zip did not contain normalized timestamps'
-fi
+ # Check that -interface.jar timestamps are normalized:
+ if [[ "$(TZ=UTC $JAR tvf $TEST_TMPDIR/testzip.jar)" != *'Tue Jan 01 00:00:00 UTC 1980'* ]]; then
+ fail 'Zip did not contain normalized timestamps'
+ fi
-grep '^test/jar/Foo\.java$' $TEST_TMPDIR/testzip.list > /dev/null \
- || fail 'Foo.java not found in output jar.'
-grep '^test/jar/Bar\.java$' $TEST_TMPDIR/testzip.list > /dev/null \
- || fail 'Bar.java not found in output jar.'
-grep '^test/jar/Outer\.java$' $TEST_TMPDIR/testzip.list > /dev/null \
- || fail 'Outer.java not found in output jar.'
-grep '^META-INF/MANIFEST\.MF$' $TEST_TMPDIR/testzip.list > /dev/null \
- || fail 'Manifest not found in output jar.'
+ grep '^test/jar/Foo\.java$' $TEST_TMPDIR/testzip.list > /dev/null \
+ || fail 'Foo.java not found in output jar.'
+ grep '^test/jar/Bar\.java$' $TEST_TMPDIR/testzip.list > /dev/null \
+ || fail 'Bar.java not found in output jar.'
+ grep '^test/jar/Outer\.java$' $TEST_TMPDIR/testzip.list > /dev/null \
+ || fail 'Outer.java not found in output jar.'
+ grep '^META-INF/MANIFEST\.MF$' $TEST_TMPDIR/testzip.list > /dev/null \
+ || fail 'Manifest not found in output jar.'
+else
+ echo "Warning: 'jar' command not available. Skipping test."
+fi
echo PASS